VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "VB6_ISE"
   ClientHeight    =   7140
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11370
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   476
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   758
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSend 
      Caption         =   "Send"
      Enabled         =   0   'False
      Height          =   285
      Left            =   10320
      TabIndex        =   9
      Top             =   6240
      Width           =   735
   End
   Begin VB6_ISE.okInSim InSimModule 
      Height          =   6615
      Left            =   0
      TabIndex        =   2
      Top             =   480
      Width           =   9375
      _ExtentX        =   16536
      _ExtentY        =   11668
   End
   Begin VB6_ISE.okOutSim OutSimModule 
      Height          =   6375
      Left            =   0
      TabIndex        =   4
      Top             =   480
      Visible         =   0   'False
      Width           =   9615
      _ExtentX        =   16960
      _ExtentY        =   11245
   End
   Begin VB6_ISE.okOutGauge OutGaugeModule 
      Height          =   6135
      Left            =   0
      TabIndex        =   3
      Top             =   480
      Visible         =   0   'False
      Width           =   9975
      _ExtentX        =   17595
      _ExtentY        =   10821
   End
   Begin VB6_ISE.okGateway GatewayModule 
      Height          =   5775
      Left            =   0
      TabIndex        =   5
      Top             =   480
      Width           =   10215
      _ExtentX        =   18018
      _ExtentY        =   10186
   End
   Begin VB6_ISE.okBrowser BrowserModule 
      Height          =   5415
      Left            =   0
      TabIndex        =   1
      Top             =   480
      Visible         =   0   'False
      Width           =   10455
      _ExtentX        =   16536
      _ExtentY        =   9551
   End
   Begin VB6_ISE.okTabs Tabs 
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   90
      Width           =   10455
      _ExtentX        =   18441
      _ExtentY        =   661
      LeftOffset      =   8
   End
   Begin VB.TextBox txtOut 
      Height          =   1815
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   4320
      Width           =   11340
   End
   Begin VB.TextBox txtSend 
      Enabled         =   0   'False
      Height          =   285
      Left            =   0
      MaxLength       =   63
      TabIndex        =   7
      Top             =   6240
      Width           =   10215
   End
   Begin VB.Label lblGrip 
      BackStyle       =   0  'Transparent
      Caption         =   "o"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   12
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   225
      Left            =   11040
      MousePointer    =   8  'Size NW SE
      TabIndex        =   8
      Top             =   6240
      Width           =   225
   End
   Begin VB.Menu mnuMainMenu 
      Caption         =   "Main"
      Visible         =   0   'False
      Begin VB.Menu mnuMain 
         Caption         =   "Exit"
         Index           =   0
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents Tray As okTray
Attribute Tray.VB_VarHelpID = -1
Private WithEvents InSim As okInSimClient
Attribute InSim.VB_VarHelpID = -1

Private m_blnMouseDown As Boolean

'api to resize to window when on the resize label
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const WM_NCLBUTTONDOWN = &HA1
Private Const HTBOTTOMRIGHT = 17

Private Sub Form_Load()
    Me.Caption = App.Title & " " & App.Major & "." & App.Minor & "." & App.Revision
    
    'get a reference to the global InSim object
    Set InSim = g_InSim
    
    'setup the rest of the form. icon, tray, tabs and modules.. (possible plugin system? :P )
    Me.Icon = LoadResPicture("101", vbResIcon)
    Call SetIcon(Me.hWnd, "101")

    Set Tray = New okTray
    Call Tray.TrayAdd(Me, App.Title)

    Call Tabs.Add("InSim")
    Call Tabs.Add("OutSim (Car Position)")
    Call Tabs.Add("OutGauge (Dashboard)")
    Call Tabs.Add("Gateway")
    Call Tabs.Add("Browser..")
    
    Call InSimModule.Initialize
    Call OutSimModule.Initialize
    Call OutGaugeModule.Initialize
    Call GatewayModule.Initialize
    Call BrowserModule.Initialize
End Sub

'these next 3 form events give the "Splitter bar" using the space between other controls
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Y < txtOut.Top And Y > txtOut.Top - 6 Then m_blnMouseDown = True
End Sub
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error Resume Next
    
    Me.MousePointer = IIf(Y < txtOut.Top And Y > txtOut.Top - 6, vbSizeNS, 0)
    If m_blnMouseDown And Y > (InSimModule.Top + 150) Then
        Me.MousePointer = vbSizeNS
        
        txtOut.Top = Y + 3
        txtOut.Height = txtSend.Top - txtOut.Top
        Call Form_Resize
    End If
End Sub
Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_blnMouseDown = False
    Me.MousePointer = 0
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    
    If Me.WindowState = vbMinimized Then
        Call Me.Hide  'minimize to tray
    Else
        Call lblGrip.Move(Me.ScaleWidth - lblGrip.Width, Me.ScaleHeight - lblGrip.Height)
        Call cmdSend.Move(lblGrip.Left - cmdSend.Width, Me.ScaleHeight - 2 - cmdSend.Height)
        Call txtSend.Move(0, Me.ScaleHeight - 2 - txtSend.Height, Me.ScaleWidth - lblGrip.Width - cmdSend.Width - 6)
        Call txtOut.Move(0, txtSend.Top - 2 - txtOut.Height, Me.ScaleWidth)

        Call Tabs.Move(0, Tabs.Top, Me.ScaleWidth)
        Call InSimModule.Move(0, InSimModule.Top, Tabs.Width, txtOut.Top - 6 - InSimModule.Top)
        Call OutSimModule.Move(0, OutSimModule.Top, Tabs.Width, txtOut.Top - 6 - OutSimModule.Top)
        Call OutGaugeModule.Move(0, OutGaugeModule.Top, Tabs.Width, txtOut.Top - 6 - OutGaugeModule.Top)
        Call GatewayModule.Move(0, GatewayModule.Top, Tabs.Width, txtOut.Top - 6 - GatewayModule.Top)
        Call BrowserModule.Move(0, BrowserModule.Top, Tabs.Width, txtOut.Top - 6 - BrowserModule.Top)
    End If
End Sub
Private Sub Form_Unload(Cancel As Integer)
    Call InSim.Disconnect
    Call Tray.TrayRemove
End Sub

Private Sub Tray_TrayClick(ByVal Button As Integer)
    'restore/minimize on click, menu on right-click
    If Button = 1 Then
        If Me.WindowState = vbNormal Then
            Me.WindowState = vbMinimized
        Else
            Me.WindowState = vbNormal
            Me.Show
        End If
    End If
    If Button = 2 Then PopupMenu mnuMainMenu
End Sub

'if you check out the menu editor for this form, you can create a menu for anything you can right-click.
'in this case, the main menu is for the tray icon
Private Sub mnuMain_Click(Index As Integer)
    Select Case Index
        Case 0: Unload Me
    End Select
End Sub

'only show the module associated with the tab clicked
Private Sub Tabs_Clicked(Index As Integer, Button As Integer)
    InSimModule.Visible = False
    OutSimModule.Visible = False
    OutGaugeModule.Visible = False
    GatewayModule.Visible = False
    BrowserModule.Visible = False
    
    Select Case Index
        Case 0: InSimModule.Visible = True
        Case 1: OutSimModule.Visible = True
        Case 2: OutGaugeModule.Visible = True
        Case 3: GatewayModule.Visible = True
        Case 4: BrowserModule.Visible = True
    End Select
End Sub

'output and change the icons and labels on dis/connect
Private Sub InSim_Connected()
    Me.Icon = LoadResPicture("102", vbResIcon)
    Call SetIcon(Me.hWnd, "102", False)
    Call Tray.TrayUpdate(NIIF_NONE, "Connected")
    
    txtSend.Enabled = True
    cmdSend.Enabled = True
End Sub
Private Sub InSim_Disconnected()
    Me.Icon = LoadResPicture("101", vbResIcon)
    Call SetIcon(Me.hWnd, "101", False)
    Call Tray.TrayUpdate(NIIF_NONE, "Disconnected")
    
    Call Output("disconnected")
    txtSend.Enabled = False
    cmdSend.Enabled = False
End Sub

Private Sub txtOut_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Me.MousePointer = 0
End Sub
Private Sub txtSend_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then Call cmdSend_Click
End Sub

Private Sub cmdSend_Click()
    If txtSend.Text <> "" Then
        Call InSim.SendMessage(txtSend.Text)
        txtSend.Text = ""
    End If
End Sub

'the size grip api (so that's what the Marlett font is for!?)
Private Sub lblGrip_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
   Call ReleaseCapture
   Call SendMessage(Me.hWnd, WM_NCLBUTTONDOWN, HTBOTTOMRIGHT, ByVal 0&)
End Sub
