VERSION 5.00
Begin VB.UserControl okBrowser 
   ClientHeight    =   5430
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9300
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   362
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   620
   Begin VB.TextBox txtOut 
      Height          =   4455
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   4
      Top             =   960
      Width           =   9300
   End
   Begin VB.TextBox txtAddress 
      Enabled         =   0   'False
      Height          =   285
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   6015
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "save"
      Enabled         =   0   'False
      Height          =   285
      Left            =   6960
      TabIndex        =   2
      Top             =   120
      Width           =   735
   End
   Begin VB.CheckBox chkHeader 
      Caption         =   "show header"
      Enabled         =   0   'False
      Height          =   255
      Left            =   7800
      TabIndex        =   1
      Top             =   165
      Width           =   1335
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "OK!"
      Enabled         =   0   'False
      Height          =   285
      Left            =   6240
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
   Begin VB.Label lblStatus 
      BackStyle       =   0  'Transparent
      Caption         =   "Not connected.."
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   690
      Width           =   9015
   End
   Begin VB.Line Line1 
      X1              =   0
      X2              =   620
      Y1              =   34
      Y2              =   34
   End
End
Attribute VB_Name = "okBrowser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private HTTPSocket As New okSocket
Private WithEvents HTTPClient As okHTTPClient
Attribute HTTPClient.VB_VarHelpID = -1

Private Const BROWSER_ID = "zee_browser"

Private m_strCurrentHeader As String
Private m_strCurrentData As String

Public Sub Initialize()
    If HTTPSocket.Initilize(UserControl.hWnd, g_Subclass) Then
        Set HTTPClient = g_HTTP
        Call ToggleControls(HTTPClient.Initilize(HTTPSocket))
    Else
        'socket error
        Call Output("could not initilize http socket!?")
    End If
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    
    Call chkHeader.Move(UserControl.ScaleWidth - 8 - chkHeader.Width)
    Call cmdSave.Move(chkHeader.Left - 8 - cmdSave.Width)
    Call cmdGo.Move(cmdSave.Left - 8 - cmdGo.Width)
    Call txtAddress.Move(8, txtAddress.Top, cmdGo.Left - 16)
    Call lblStatus.Move(8, lblStatus.Top, UserControl.ScaleWidth - 16)
    Line1.x2 = UserControl.ScaleWidth
    Call txtOut.Move(0, txtOut.Top, UserControl.ScaleWidth, UserControl.ScaleHeight - txtOut.Top)
End Sub

Private Sub txtAddress_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then Call cmdGo_Click
End Sub

Private Sub cmdGo_Click()
    If txtAddress.Text <> "" Then Call ToggleControls(Not HTTPClient.Request(BROWSER_ID, txtAddress.Text))
End Sub
Private Sub cmdSave_Click()
    Dim intFF As Integer

    intFF = FreeFile
    Open App.Path & "\output.txt" For Output As #intFF
        Print #intFF, m_strCurrentData
    Close #intFF

    Call Output("data saved to " & App.Path & "\output.txt")
End Sub

Private Sub chkHeader_Click()
    txtOut.Text = IIf(chkHeader.Value, m_strCurrentHeader, "") & Replace(m_strCurrentData, vbLf, vbNewLine)
End Sub

Private Sub txtOut_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    frmMain.MousePointer = 0
End Sub

Private Sub ToggleControls(ByVal Enabled As Boolean)
    txtAddress.Enabled = Enabled
    cmdGo.Enabled = Enabled
    cmdSave.Enabled = Enabled
    chkHeader.Enabled = Enabled
End Sub

Private Sub HTTPClient_ReceiveProgress(ByVal varID As Variant, ByVal lngRecv As Long, ByVal lngTotal As Long)
    If varID = BROWSER_ID Then
        If lngTotal > 0 Then
            lblStatus.Caption = lngRecv & "/" & lngTotal & " - " & Format(lngRecv / lngTotal, "###%")
        Else
            lblStatus.Caption = lngRecv & "/" & lngTotal & " - unknown"
        End If
    End If
End Sub
Private Sub HTTPClient_Received(ByVal varID As Variant, ByVal strResponse As String, ByVal strHeader As String, ByVal strData As String)
    If varID = BROWSER_ID Then
        m_strCurrentHeader = strHeader
        m_strCurrentData = strData
        lblStatus.Caption = lblStatus.Caption & " - " & strResponse
        
        Call ToggleControls(True)
        txtOut.Text = IIf(chkHeader.Value, m_strCurrentHeader, "") & Replace(m_strCurrentData, vbLf, vbNewLine)
    End If
End Sub
Private Sub HTTPClient_Status(ByVal varID As Variant, ByVal strMsg As String)
    If varID = BROWSER_ID Then lblStatus.Caption = strMsg
End Sub
Private Sub HTTPClient_Closed(ByVal varID As Variant)
    If varID = BROWSER_ID Then
        lblStatus.Caption = lblStatus.Caption & " - closed"
        Call ToggleControls(True)
    End If
End Sub
